!{\src2tex{textfont=tt}}
!!****m* etsf_dims/etsf_io_dims_trace
!! NAME
!!  etsf_io_dims_trace
!!
!! FUNCTION
!!    Output for each variable its value. Essentially used for debugging.
!!
!! COPYRIGHT
!!  Copyright (C) 2006-2010 (Damien Caliste)
!!  This file is distributed under the terms of the
!!  GNU Lesser General Public License, see the COPYING file
!!  or http://www.gnu.org/copyleft/lesser.txt .
!!
!! INPUTS
!! * dims <type(etsf_dims)> = 
!!     the structure that should be output on screen.
!!
!! NOTES
!!  This file has been automatically generated by the autogen_subroutines.py
!!  script. Any change you would bring to it will systematically be
!!  overwritten.
!!
!! SOURCE
subroutine etsf_io_dims_trace(dims)

  !Arguments ------------------------------------
  type(etsf_dims), intent(in) :: dims

  !Local variables-------------------------------
  character(len = *), parameter :: my_name = 'etsf_io_dims_trace'


  ! *************************************************************************

!DEBUG
!write (*,*) 'etsf_io_dims_trace : enter'
!ENDDEBUG

  write(*, "(A42,A,I6)") "character_string_length", &
    & ": ", dims%character_string_length
  write(*, "(A42,A,I6)") "complex", &
    & ": ", dims%complex
  write(*, "(A42,A,I6)") "max_number_of_angular_momenta", &
    & ": ", dims%max_number_of_angular_momenta
  write(*, "(A42,A,I6)") "max_number_of_basis_grid_points", &
    & ": ", dims%max_number_of_basis_grid_points
  write(*, "(A42,A,I6)") "max_number_of_coefficients", &
    & ": ", dims%max_number_of_coefficients
  write(*, "(A42,A,I6)") "max_number_of_projectors", &
    & ": ", dims%max_number_of_projectors
  write(*, "(A42,A,I6)") "max_number_of_states", &
    & ": ", dims%max_number_of_states
  write(*, "(A42,A,I6)") "number_of_atoms", &
    & ": ", dims%number_of_atoms
  write(*, "(A42,A,I6)") "number_of_atom_species", &
    & ": ", dims%number_of_atom_species
  write(*, "(A42,A,I6)") "number_of_cartesian_directions", &
    & ": ", dims%number_of_cartesian_directions
  write(*, "(A42,A,I6)") "number_of_coefficients_dielectric_function", &
    & ": ", dims%number_of_coefficients_dielectric_function
  write(*, "(A42,A,I6)") "number_of_components", &
    & ": ", dims%number_of_components
  write(*, "(A42,A,I6)") "number_of_frequencies_dielectric_function", &
    & ": ", dims%number_of_frequencies_dielectric_function
  write(*, "(A42,A,I6)") "number_of_grid_points_vector1", &
    & ": ", dims%number_of_grid_points_vector1
  write(*, "(A42,A,I6)") "number_of_grid_points_vector2", &
    & ": ", dims%number_of_grid_points_vector2
  write(*, "(A42,A,I6)") "number_of_grid_points_vector3", &
    & ": ", dims%number_of_grid_points_vector3
  write(*, "(A42,A,I6)") "number_of_kpoints", &
    & ": ", dims%number_of_kpoints
  write(*, "(A42,A,I6)") "number_of_localization_regions", &
    & ": ", dims%number_of_localization_regions
  write(*, "(A42,A,I6)") "number_of_qpoints_dielectric_function", &
    & ": ", dims%number_of_qpoints_dielectric_function
  write(*, "(A42,A,I6)") "number_of_qpoints_gamma_limit", &
    & ": ", dims%number_of_qpoints_gamma_limit
  write(*, "(A42,A,I6)") "number_of_reduced_dimensions", &
    & ": ", dims%number_of_reduced_dimensions
  write(*, "(A42,A,I6)") "number_of_spinor_components", &
    & ": ", dims%number_of_spinor_components
  write(*, "(A42,A,I6)") "number_of_spins", &
    & ": ", dims%number_of_spins
  write(*, "(A42,A,I6)") "number_of_symmetry_operations", &
    & ": ", dims%number_of_symmetry_operations
  write(*, "(A42,A,I6)") "number_of_vectors", &
    & ": ", dims%number_of_vectors
  write(*, "(A42,A,I6)") "real_or_complex_coefficients", &
    & ": ", dims%real_or_complex_coefficients
  write(*, "(A42,A,I6)") "real_or_complex_density", &
    & ": ", dims%real_or_complex_density
  write(*, "(A42,A,I6)") "real_or_complex_gw_corrections", &
    & ": ", dims%real_or_complex_gw_corrections
  write(*, "(A42,A,I6)") "real_or_complex_potential", &
    & ": ", dims%real_or_complex_potential
  write(*, "(A42,A,I6)") "real_or_complex_wavefunctions", &
    & ": ", dims%real_or_complex_wavefunctions
  write(*, "(A42,A,I6)") "symbol_length", &
    & ": ", dims%symbol_length
  write(*, "(A42,A,I6)") "my_max_number_of_coefficients", &
    & ": ", dims%my_max_number_of_coefficients
  write(*, "(A42,A,I6)") "my_max_number_of_states", &
    & ": ", dims%my_max_number_of_states
  write(*, "(A42,A,I6)") "my_number_of_components", &
    & ": ", dims%my_number_of_components
  write(*, "(A42,A,I6)") "my_number_of_grid_points_vect1", &
    & ": ", dims%my_number_of_grid_points_vect1
  write(*, "(A42,A,I6)") "my_number_of_grid_points_vect2", &
    & ": ", dims%my_number_of_grid_points_vect2
  write(*, "(A42,A,I6)") "my_number_of_grid_points_vect3", &
    & ": ", dims%my_number_of_grid_points_vect3
  write(*, "(A42,A,I6)") "my_number_of_kpoints", &
    & ": ", dims%my_number_of_kpoints
  write(*, "(A42,A,I6)") "my_number_of_spins", &
    & ": ", dims%my_number_of_spins

!DEBUG
!write (*,*) 'etsf_io_dims_trace : exit'
!ENDDEBUG

end subroutine etsf_io_dims_trace
!!***
