!{\src2tex{textfont=tt}}
!!****m* etsf_vars/etsf_io_vars_free
!! NAME
!!  etsf_io_vars_free
!!
!! FUNCTION
!!    Free the given variable list.
!!
!! COPYRIGHT
!!  Copyright (C) 2006-2010 (Damien Caliste)
!!  This file is distributed under the terms of the
!!  GNU Lesser General Public License, see the COPYING file
!!  or http://www.gnu.org/copyleft/lesser.txt .
!!
!! SIDE EFFECTS
!! * vars_infos <type(etsf_vars)> = 
!!
!! NOTES
!!  This file has been automatically generated by the autogen_subroutines.py
!!  script. Any change you would bring to it will systematically be
!!  overwritten.
!!
!! SOURCE
subroutine etsf_io_vars_free(vars_infos)

  !Arguments ------------------------------------
  type(etsf_vars), intent(inout) :: vars_infos

  !Local variables-------------------------------
  character(len = *), parameter :: my_name = 'etsf_io_vars_free'


  ! *************************************************************************

!DEBUG
!write (*,*) 'etsf_io_vars_free : enter'
!ENDDEBUG

  ! Deallocate all associated pointers.
  if (associated(vars_infos%parent)) then
    call etsf_io_low_free_all_var_infos(vars_infos%parent)
  end if
  if (associated(vars_infos%group)) then
    deallocate(vars_infos%group)
  end if
  if (associated(vars_infos%varid)) then
    deallocate(vars_infos%varid)
  end if
  if (associated(vars_infos%split)) then
    deallocate(vars_infos%split)
  end if


!DEBUG
!write (*,*) 'etsf_io_vars_free : exit'
!ENDDEBUG

end subroutine etsf_io_vars_free
!!***
